Loading...
Searching...
No Matches
Sip_allow_events

## Macros

#define | sip_allow_events(sip)
| Access a SIP Allow-Events header structure sip_allow_events_t from sip_t.
#define | SIP_ALLOW_EVENTS_INIT()
| Initializer for structure sip_allow_events_t.
#define | SIPTAG_ALLOW_EVENTS(x)
| Tag list item for pointer to a Allow-Events header structure sip_allow_events_t.
#define | SIPTAG_ALLOW_EVENTS_REF(x)
| Tag list item for reference to a Allow-Events header pointer.
#define | SIPTAG_ALLOW_EVENTS_STR(s)
| Tag list item for string with Allow-Events header value.
#define | SIPTAG_ALLOW_EVENTS_STR_REF(x)
| Tag list item for reference to a Allow-Events header string.

## Typedefs

typedef msg_list_t | sip_allow_events_t
| @

## Functions

issize_t | sip_allow_events_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Allow-Events header.
issize_t | sip_allow_events_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Allow-Events header.
sip_allow_events_t * | sip_allow_events_init (sip_allow_events_t x[1])
| Initialize a structure sip_allow_events_t.
int | sip_is_allow_events (sip_header_t const *header)
| Test if header object is instance of sip_allow_events_t.
sip_allow_events_t * | sip_allow_events_dup (su_home_t *home, sip_allow_events_t const *hdr))
| Duplicate a list of Allow-Events header header structures sip_allow_events_t.
sip_allow_events_t * | sip_allow_events_copy (su_home_t *home, sip_allow_events_t const *hdr))
| Copy a list of Allow-Events header header structures sip_allow_events_t.
sip_allow_events_t * | sip_allow_events_make (su_home_t *home, char const *s))
| Make a Allow-Events header structure sip_allow_events_t.
sip_allow_events_t * | sip_allow_events_format (su_home_t *home, char const *fmt,...)))
| Make a Allow-Events header from formatting result.

## Variables

msg_hclass_t | sip_allow_events_class []
| Header class for Allow-Events header.
tag_typedef_t | siptag_allow_events
| Tag for Allow-Events header object.
tag_typedef_t | siptag_allow_events_str
| Tag for string with Allow-Events header value.

## Detailed Description

## Macro Definition Documentation

## SIP_ALLOW_EVENTS_INIT

#define SIP_ALLOW_EVENTS_INIT | ( |  | ) |

Initializer for structure sip_allow_events_t.

A static sip_allow_events_t structure for Allow-Events header must be initialized with the SIP_ALLOW_EVENTS_INIT() macro. For instance,

sip_allow_events_t sip_allow_events = SIP_ALLOW_EVENTS_INIT;
sip_allow_events_t
msg_list_t sip_allow_events_t
@
Definition sip.h:205
SIP_ALLOW_EVENTS_INIT
#define SIP_ALLOW_EVENTS_INIT()
Initializer for structure sip_allow_events_t.
Definition sip_protos.h:8954
sip_allow_events
#define sip_allow_events(sip)
Access a SIP Allow-Events header structure sip_allow_events_t from sip_t.
Definition sip_protos.h:8937

## SIPTAG_ALLOW_EVENTS

#define SIPTAG_ALLOW_EVENTS | ( |  | x | ) |

Tag list item for pointer to a Allow-Events header structure sip_allow_events_t.

The SIPTAG_ALLOW_EVENTS() macro is used to include a tag item with a pointer to a sip_allow_events_t structure in a tag list.

Parameters

  x | pointer to a sip_allow_events_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_ALLOW_EVENTS_REF().

## SIPTAG_ALLOW_EVENTS_STR

#define SIPTAG_ALLOW_EVENTS_STR | ( |  | s | ) |

Tag list item for string with Allow-Events header value.

The SIPTAG_ALLOW_EVENTS_STR() macro is used to include a tag item with a string containing value of a sip_allow_events_t header in a tag list.

Parameters

  s | pointer to a string containing Allow-Events header value, or NULL.

The string in SIPTAG_ALLOW_EVENTS_STR() can be converted to a sip_allow_events_t header structure by giving the string s has second argument to function sip_allow_events_make().

The corresponding tag taking reference parameter is SIPTAG_ALLOW_EVENTS_STR_REF().

## Typedef Documentation

## sip_allow_events_t

typedef msg_list_t sip_allow_events_t

@

The Allow-Events header is used to indicate which events or classes of events the notifier supports. Its syntax is defined in RFC 3265 as follows:

Allow-Events = ( "Allow-Events" / "u" ) HCOLON event-type
*(COMMA event-type)

The parsed Allow-Events header is stored in sip_allow_events_t structure.

Note that the event name is case-sensitive. The event "Presence" is different from "presence". However, it is very unwise to use such event names.

See also
  Event, RFC 3265, msg_header_find_item(), msg_header_replace_item(), msg_header_remove_item()

The structure sip_allow_events_t contains representation of an Allow-Events header.

The sip_allow_events_t is defined as follows:

typedef struct msg_list_s
{
msg_common_t k_common[1]; // Common fragment info
msg_list_t *k_next; // Link to next header
msg_param_t *k_items; // List of items
} sip_allow_events_t;
msg_list_t
struct msg_list_s msg_list_t
msg_common_t
struct msg_common_s msg_common_t
msg_list_s
msg_list_s::k_common
msg_common_t k_common[1]
msg_list_s::k_next
msg_list_t * k_next
msg_list_s::k_items
msg_param_t * k_items

## Function Documentation

## sip_allow_events_copy()

sip_allow_events_t * sip_allow_events_copy | ( | su_home_t * | home,
|  | sip_allow_events_t const * | hdr )

inline

Copy a list of Allow-Events header header structures sip_allow_events_t.

The function sip_allow_events_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  allow_events = sip_allow_events_copy(home, sip->sip_allow_events);
  sip_allow_events_copy
  sip_allow_events_t * sip_allow_events_copy(su_home_t *home, sip_allow_events_t const *hdr))
  Copy a list of Allow-Events header header structures sip_allow_events_t.
  Definition sip_protos.h:9084

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_allow_events_dup()

sip_allow_events_t * sip_allow_events_dup | ( | su_home_t * | home,
|  | sip_allow_events_t const * | hdr )

inline

Duplicate a list of Allow-Events header header structures sip_allow_events_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  allow_events = sip_allow_events_dup(home, sip->sip_allow_events);
  sip_allow_events_dup
  sip_allow_events_t * sip_allow_events_dup(su_home_t *home, sip_allow_events_t const *hdr))
  Duplicate a list of Allow-Events header header structures sip_allow_events_t.
  Definition sip_protos.h:9041

Returns
  A pointer to the newly duplicated sip_allow_events_t header structure, or NULL upon an error.

## sip_allow_events_format()

sip_allow_events_t * sip_allow_events_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Allow-Events header from formatting result.

Make a new sip_allow_events_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_allow_events_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_allow_events_init()

sip_allow_events_t * sip_allow_events_init | ( | sip_allow_events_t | x[1] | ) |

inline

Initialize a structure sip_allow_events_t.

An sip_allow_events_t structure for Allow-Events header can be initialized with the sip_allow_events_init() function/macro. For instance,

sip_allow_events_t sip_allow_events;
sip_allow_events_init(&sip_allow_events);
sip_allow_events_init
sip_allow_events_t * sip_allow_events_init(sip_allow_events_t x[1])
Initialize a structure sip_allow_events_t.
Definition sip_protos.h:8972

## sip_allow_events_make()

sip_allow_events_t * sip_allow_events_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Allow-Events header structure sip_allow_events_t.

The function sip_allow_events_make() makes a new sip_allow_events_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_allow_events_t header structure, or NULL upon an error.

## sip_is_allow_events()

int sip_is_allow_events | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_allow_events_t.

Check if the header class is an instance of Allow-Events header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header allow_events
  0 | (false) otherwise

## Variable Documentation

## sip_allow_events_class

msg_hclass_t sip_allow_events_class[]

extern

Header class for Allow-Events header.

The header class sip_allow_events_class defines how a SIP Allow-Events header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_allow_events_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.